import java.awt.Component;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

class SourceListener implements MouseMotionListener{
  Matrix h;
  Component schermo;

  public void giveMatrix(Matrix m){
    this.h=(Matrix)m.clone();
  }

  public void givePanel(Component c){
    this.schermo=c;
  }

  public void mouseDragged(MouseEvent e) {
    Point me=new Point(e.getX(),e.getY());
    Matrix p=new Matrix(3,1);
    Dimension p1=e.getComponent().getSize();
    p.elem[0][0]=((double)me.x) / ((double)p1.width);
    p.elem[1][0]=((double)me.y) / ((double)p1.height);
    p.elem[2][0]=1;

    if (p.elem[0][0]<=0) p.elem[0][0]=0;
    if (p.elem[0][0]>=1) p.elem[0][0]=1;
    if (p.elem[1][0]<=0) p.elem[1][0]=0;
    if (p.elem[1][0]>=1) p.elem[1][0]=1;
    Matrix r=this.h.mult(p);
    schermo.getGraphics().drawOval(
      (int)(r.elem[0][0]/r.elem[2][0]),
      (int)(r.elem[1][0]/r.elem[2][0]),
      1,1
    );

    e.getComponent().getGraphics().drawOval(
      me.x,me.y,1,1);

    //TODO: implement this java.awt.event.MouseMotionListener method;
  }

  public void mouseMoved(MouseEvent e) {
    //TODO: implement this java.awt.event.MouseMotionListener method;
  }

}


